function space_frac_eq
% u_t = D_{|x|}^{alf}u + f
tic
sel = 0;  
fdm = 3;
nalf = [1.2 1.5 1.8];  
nalf2 = nalf;
q = 1; % see function  [arr1,arr2] = frac_basis(alf,N,q)
% Table 4.14: q = 5, fdm = 3
% Table 4.15: q = 1, fdm = 3
% Table 4.16: q = 2, fdm = 3
% Table 4.17: q = 3, fdm = 3
% Table 4.18: q = 4, fdm = 3
for kk=1:length(nalf)
    alf = nalf(kk); alf2=nalf2(kk); 
    [uv,gv,N,tau,nodes,nu1,nu2,T,alpha,uav,ubv,ut0] = solution(sel,alf,alf2);
    nn=length(tau); ee=zeros(nn,1); ee2=ee;
for k=1:nn
    switch fdm
        case 1
            [uu,e,e2]=euler_f(uv,gv,uav,ubv,N(k),tau(k),nodes,nu1,nu2,T,alf,ut0,q);
            ee(k) = e; ee2(k) = e2;
        case 2
            [uu,e,e2]=euler_b(uv,gv,uav,ubv,N(k),tau(k),nodes,nu1,nu2,T,alf,ut0,q);
            ee(k) = e; ee2(k) = e2;
        case 3  % CN 
            [uu,e,e2]=fdm_cn(uv,gv,uav,ubv,N(k),tau(k),nodes,nu1,nu2,T,alf,ut0,q);
            ee(k) = e; ee2(k) = e2;
    end
end
odr = myorder(1./N,tau,ee);  odr2 = myorder(1./N,tau,ee2);  
fid = fopen('fem_L1.txt','a');
fprintf('alf = %s,  T = %s\n',num2str(alf),num2str(T));
A=[N,1./tau,ee,odr,ee2,odr2];
s={'N','1/tau','max-error','order','L^2-error','order'};
output(s,A);
fprintf('cputime = %-10.4f\n\n',toc);
% % % % % % % % % % % % % % % % % % % % % 
fprintf(fid,'alf = %s, T = %s\n',num2str(alf),num2str(T));
output1(s,A,fid); 
fprintf(fid,'cputime = %-10.4f\n\n',toc);
end
% END

function [uu,e,e2]=euler_f(uv,gv,uav,ubv,N,tau,nodes,nu1,nu2,T,alf,ut0,q)
% % uniform grids
% Grunwald-Letnikov formula, forward Euler 
xa = nodes(1);   xb=nodes(2);    
h = (xb-xa)/N;   xx = xa:h:xb+1e-10;  xx=xx';   xxx=xx;
% alf = 1-alf0;
% % % % % % 
ne = round(T/tau);
% % % % % % % % % % % % % % % % % % % % % % %
% [mm,ss] = basis(p,N,xx);
% q = 1;  %%%   sel = 1,2,3,4
[ss1,ss2] = frac_basis(alf,N,q); 
% ss = (ss1+ss2)/h^(alf-1);
mm = eye(N+1)*h;  mm = mm(2:end-1,:);   
arrR = mm + tau/h^(alf-1)*(nu1(1,1)*ss1+nu2(1,1)*ss2);
mm = sparse(mm);  arr = mm;
bnd = [arr(:,1),arr(:,end)]; 
arr = arr(:,2:end-1);        
%------------- initial ------------
xx = xxx;
p=1; uu = zeros(p*N+1,ne); 
u0 = ut0(xx);    uu(:,1) = u0;  
tt = 0:tau:T+1e-10; 
%-----------------------------
for n = 1:ne      
    ua = uav(tt(n+1));   ub = ubv(tt(n+1)); 
    rhs = -bnd*[ua;ub] + arrR*uu(:,n) + tau*(mm*gv(xx,tt(n))); 
    u2 = arr\rhs; 
    uu(:,n+1) = [ua;u2;ub];   
end
e = norm(uu(:,end)-uv(xx,T),inf);
e2 = h/p*(uu(:,end)-uv(xx,T)).^2;
e2 = sqrt(sum(e2));
e3 = funuv(uv,xx,tt);   e = max(max(abs(uu-e3)));
e2 = norm(sqrt(sum(h/p*(e3-uu).^2)),inf);
e;
%END
function [uu,e,e2]=euler_b(uv,gv,uav,ubv,N,tau,nodes,nu1,nu2,T,alf,ut0,q)
% % uniform grids
% Grunwald-Letnikov formula, forward Euler 
xa = nodes(1);   xb=nodes(2);    
h = (xb-xa)/N;   xx = xa:h:xb+1e-10;  xx=xx';   xxx=xx;
% alf = 1-alf0;
% % % % % % 
ne = round(T/tau);
% % % % % % % % % % % % % % % % % % % % % % %
% [mm,ss] = basis(p,N,xx);
% q = 3;  %%%   sel = 1,2,3,4
[ss1,ss2] = frac_basis(alf,N,q); 
% ss = (ss1+ss2)/h^(alf-1);
mm = eye(N+1)*h;  mm = mm(2:end-1,:);   
arr = mm - tau/h^(alf-1)*(nu1(1,1)*ss1+nu2(1,1)*ss2);
mm = sparse(mm);  arrR = mm;
bnd = [arr(:,1),arr(:,end)]; 
arr = arr(:,2:end-1);        
%------------- initial ------------
xx = xxx;
p=1;  uu = zeros(p*N+1,ne); 
u0 = ut0(xx);    uu(:,1) = u0;  
tt = 0:tau:T+1e-10; 
%-----------------------------
for n = 1:ne      
    ua = uav(tt(n+1));   ub = ubv(tt(n+1)); 
    rhs = -bnd*[ua;ub] + arrR*uu(:,n) + tau*(mm*gv(xx,tt(n))); 
    u2 = arr\rhs; 
    uu(:,n+1) = [ua;u2;ub];   
end
e = norm(uu(:,end)-uv(xx,T),inf);
e2 = h/p*(uu(:,end)-uv(xx,T)).^2;
e2 = sqrt(sum(e2));
e3 = funuv(uv,xx,tt);   e = max(max(abs(uu-e3)));
e2 = norm(sqrt(sum(h/p*(e3-uu).^2)),inf);
e;
%END
function [uu,e,e2]=fdm_cn(uv,gv,uav,ubv,N,tau,nodes,nu1,nu2,T,alf,ut0,q)
% % uniform grids
% Grunwald-Letnikov formula, forward Euler 
xa = nodes(1);   xb=nodes(2);    
h = (xb-xa)/N;   xx = xa:h:xb+1e-10;  xx=xx';   xxx=xx;
% alf = 1-alf0;
% % % % % % 
ne = round(T/tau);
% % % % % % % % % % % % % % % % % % % % % % %
% [mm,ss] = basis(p,N,xx);
% q = 5;  %%%   sel = 1,2,3,4
[ss1,ss2] = frac_basis(alf,N,q); 
% ss = (ss1+ss2)/h^(alf-1);
mm = eye(N+1)*h;  mm = mm(2:end-1,:);   
arr = mm - tau/h^(alf-1)/2*(nu1(1,1)*ss1+nu2(1,1)*ss2);
arrR = mm + tau/h^(alf-1)/2*(nu1(1,1)*ss1+nu2(1,1)*ss2);
mm = sparse(mm);  

bnd = [arr(:,1),arr(:,end)]; 
arr = arr(:,2:end-1);        
%------------- initial ------------
xx = xxx;
p=1;  uu = zeros(p*N+1,ne); 
u0 = ut0(xx);    uu(:,1) = u0;  
tt = 0:tau:T+1e-10; 
ttt=(tt(1:end-1)+tt(2:end))/2;
%-----------------------------
for n = 1:ne      
    ua = uav(tt(n+1));   ub = ubv(tt(n+1)); 
    rhs = -bnd*[ua;ub] + arrR*uu(:,n) + tau*(mm*gv(xx,ttt(n))); 
    u2 = arr\rhs; 
    uu(:,n+1) = [ua;u2;ub];   
end
e = norm(uu(:,end)-uv(xx,T),inf);
e2 = h/p*(uu(:,end)-uv(xx,T)).^2;
e2 = sqrt(sum(e2));
e3 = funuv(uv,xx,tt);   e = max(max(abs(uu-e3)));
e2 = norm(sqrt(sum(h/p*(e3-uu).^2)),inf);
e;
%END

function [uv,gv,N,tau,nodes,nu1,nu2,T,alpha,uav,ubv,ut0,dtu0]=solution(sel,alf,varargin)
% no = numel(varargin);
% % % u_t = nu1*D_{xa,x}^{alf}u + nu2*D_{x,xb}^{alf}u  + g(x,t)
switch sel
    case 0
        nodes = [0,1];   alpha=alf;
        xa = nodes(1);   xb = nodes(2);
        T = 1;
        mu1 = 1;   mu2 = 1;
%         c = -1/2/cos(alf*pi/2); 
        N = [8,16,32,64,128]';   
        tau = 1./[1000 1000 1000 1000 1000]';  
        nu1 = @(x,t) mu1;  nu2 = @(x,t) mu2;
        uv=@(x,t) cos(t)*(x.^4.*(1-x).^4);
        gv=@(x,t) -sin(t)*(x.^4.*(1-x).^4) - mu1*cos(t)*(gamma(9)/gamma(9-alf)*x.^(8-alf) - 4*gamma(8)/gamma(8-alf)*x.^(7-alf).....
            + 6*gamma(7)/gamma(7-alf)*x.^(6-alf) - 4*gamma(6)/gamma(6-alf)*x.^(5-alf) + gamma(5)/gamma(5-alf)*x.^(4-alf))....
            - mu2*cos(t)*(gamma(9)/gamma(9-alf)*((1-x).^(8-alf)) - 4*gamma(8)/gamma(8-alf)*((1-x).^(7-alf)).....
            + 6*gamma(7)/gamma(7-alf)*((1-x).^(6-alf)) - 4*gamma(6)/gamma(6-alf)*((1-x).^(5-alf)) + gamma(5)/gamma(5-alf)*((1-x).^(4-alf)));
        uav = @(t) uv(xa,t);
        ubv = @(t) uv(xb,t);
        ut0 = @(x) uv(x,0);
        dtu0 = @(x,t) 0;
    otherwise
        uv=[]; gv=[];  N=[]; tau=[]; 
        nodes=[]; nu=[]; T=[]; alpha=[]; 
end
% nu=[nu,nu2];
%END

function odr=myorder(ntau,NN,err)
n=length(ntau); 
tau(1:n,1)=ntau; N(1:n,1)=NN(1:n); 
er(1:n,1)=err(1:n);
if n==1
    odr=0; return;
end
if n>1
    if abs(ntau(1)-ntau(2))>1e-10
        odr=(log(er(1:end-1)./er(2:end)))./log(tau(1:n-1,:)./tau(2:n,:));
    else 
        odr=(log(er(1:end-1)./er(2:end)))./log(N(1:n-1,:)./N(2:n,:));
    end
end
odr=[0;odr];
%END 

function [w2,w]=weights(alf,n0,p)
n=n0+1;   j = 0:n-1;   x0 = j.'*2*pi/n;
switch p
    case 1
        w = ones(n,1); 
        f=@(z)(1-z).^alf;
        for k=1:n-1
            w(k+1)=(k-1-alf)/k*w(k); 
        end
        w2=w;
        w = real(fft(f(exp(i*x0))))/n;
    case 2
        f=@(z)(3/2 - 2*z + 0.5*z.^2).^alf;
%         fs=(3/2 - 2*t + t^2/2).^alf;
%         d1f=diff(fs,t); d1f=subs(d1f,t,0);
%         d2f=diff(fs,t,2); d2f=subs(d2f,t,0);
        w = real(fft(f(exp(i*x0))))/n;
        u=zeros(n,1);  u(1:3) = [3/2;  -2; 1/2];  
        w2=w; w2(1) = (3/2)^alf;
        ii=0:n-1;  u=sparse(u);
        for j=1:n-1
            w2(j+1) = (alf - ii(1:j)/j*(alf+1))*(w2(1:j).*u(j+1:-1:2))/u(1);
        end
%         eee=max(w2-w)
%         eee
    case 3
        f=@(z)(11/6 - 3*z + 3/2*z.^2 - z.^3/3).^alf;
        w=real(fft(f(exp(i*x0))))/n;
        
        u=zeros(n,1);  u(1:p+1) = [11/6; -3; 3/2;-1/3];  
        w2=w;  w2(1) = (u(1))^alf;
        ii=0:n-1;  u=sparse(u);
        for j=1:n-1
            w2(j+1) = (alf - ii(1:j)/j*(alf+1))*(w2(1:j).*u(j+1:-1:2))/u(1);
        end
        eee=max(w2-w);
        eee;
    case 4
        f=@(z)(25/12 - 4*z + 3*z.^2 - 4/3*z.^3 + 1/4*z.^4).^alf;
        w=real(fft(f(exp(i*x0))))/n;
        
        u=zeros(n,1);  u(1:p+1) = [25/12; -4; 3;-4/3;1/4];  
        w2=w;  w2(1) = (u(1))^alf;
        ii=0:n-1;  u=sparse(u);
        for j=1:n-1
            w2(j+1) = (alf - ii(1:j)/j*(alf+1))*(w2(1:j).*u(j+1:-1:2))/u(1);
        end
        eee=max(w2-w);
        eee;
    case 5
        f=@(z)(137/60 - 5*z + 5*z.^2 - 10*z.^3/3 + 5*z.^4/4 - z.^5/5).^alf;
        w=real(fft(f(exp(i*x0))))/n;
        
        u=zeros(n,1);  u(1:p+1) = [137/60; -5; 5; -10/3; 5/4; -1/5];  
        w2=w;  w2(1) = (u(1))^alf;
        ii=0:n-1;  u=sparse(u);
        for j=1:n-1
            w2(j+1) = (alf - ii(1:j)/j*(alf+1))*(w2(1:j).*u(j+1:-1:2))/u(1);
        end
        eee=max(w2-w);
        eee;
    case 6
        f=@(z)(147/60 - 6*z + 15/2*z.^2 - 20/3*z.^3 + 15/4*z.^4 - 6/5*z.^5 +z.^6/6).^alf;
        w=real(fft(f(exp(i*x0))))/n;
        
        u=zeros(n,1);  u(1:p+1) = [147/60; -6; 15/2; -20/3; 15/4; -6/5; 1/6];  
        w2=w;  w2(1) = (u(1))^alf;
        ii=0:n-1;  u=sparse(u);
        for j=1:n-1
            w2(j+1) = (alf - ii(1:j)/j*(alf+1))*(w2(1:j).*u(j+1:-1:2))/u(1);
        end
        eee=max(w2-w);
%         eee
end


function output(s,A)
[row,col] = size(A);
fprintf('%-10s%-10s%-16s%-8s%-16s%-8s',s{1},s{2},s{3},s{4},s{5},s{6});
fprintf('\n');
for k=1:row
    fprintf('%-10s%-10s%-16.4e%-8.4f%-16.4e %-8.4f',......
        num2str(A(k,1)),num2str(A(k,2)),A(k,3),A(k,4),A(k,5),A(k,6));
    fprintf('\n');
end
% fprintf('\n');
% END

function output1(s,A,fid)
[row,col] = size(A);
fprintf(fid,'%-10s%-10s%-16s%-8s%-16s%-8s',s{1},s{2},s{3},s{4},s{5},s{6});
fprintf(fid,'\n');
for k=1:row
    fprintf(fid,'%-10s%-10s%-16.6e%-8.4f%-16.6e %-8.4f',.....
        num2str(A(k,1)),num2str(A(k,2)),A(k,3),A(k,4),A(k,5),A(k,6));
    fprintf(fid,'\n');
end
fprintf(fid,'\n');
% END
function u=funuv(uv,x,t)
nt=length(t); N=length(x);
u=zeros(N,nt);
for k=1:nt
    u(:,k)=uv(x,t(k));
end


function [arr1,arr2] = frac_basis(alf,N,q)
arr1 = zeros(N-1, N+1); arr2 = arr1;
w  = weights(alf,N+2,1)';
switch q
    case 1 % Shifted Grunwald-Letnikov formula
        for i=1:N-1
            arr1(i,1:i+2) = w(i+2:-1:1);  arr2(i,i:N+1) = w(1:N+2-i);
        end
    case 2 % fractional central difference
        arr1 = w_arr_or2(alf,N);  arr1 = arr1(2:end-1,:);  arr2 = arr1;
        arr1 = arr1*cos(alf*pi/2); arr2 = arr2*cos(alf*pi/2); 
    case 3 % second-order weighted shifted formula
        ww = w; ww(1) = alf/2*w(1); 
        ww(2:end) = alf/2*w(2:end) + (2-alf)/2*w(1:end-1);
        for i=1:N-1
            arr1(i,1:i+2) = ww(i+2:-1:1);  arr2(i,i:N+1) = ww(1:N+2-i);
        end
    case 4 % second-order weighted shifted formula
        ww = w; ww(1) = (2+alf)/4*w(1);  ww(2) = (2+alf)/4*w(2);
        ww(3:end) = (2+alf)/4*w(3:end) + (2-alf)/4*w(1:end-2);
        for i=1:N-1
            arr1(i,1:i+2) = ww(i+2:-1:1);  arr2(i,i:N+1) = ww(1:N+2-i);
        end
    case 5 % Standard Grunwald-Letnikov formula
        for i=1:N-1
            arr1(i,1:i+1) = w(i+1:-1:1);  arr2(i,i+1:N+1) = w(1:N+1-i);
        end
    otherwise
        arr1 = []; arr2 = [];
end


function w = w_arr_or2(alf,N)
% second order matrix
w0 = weight_order2(N+1,alf);   w = zeros(N+1);        
for i=1:N+1
    w(i,1:i) = w0(i:-1:1);  w(i,i+1:N+1) = w0(2:N+2-i);   
end
w;
% END
function w = weight_order2(ne,alf)
w = zeros(ne+1,1);
w(1) = gamma(alf+1)/gamma(alf/2+1)^2;
for k=0:ne
    w(k+2) = (k-alf/2)/(alf/2+k+1)*w(k+1);
end

function [w,w1,w2] = weight_arr_order_1(alf,N)
ww  = weights(alf,N+2,1)';  
w1 = zeros(N-1,N+1);  w2 = w1;        
for i=1:N-1
    w1(i,1:i+2) = ww(i+2:-1:1);    w2(i,i:N+1) = ww(1:N+2-i);
end   
% 
w = w1 + w2;
% w = w*0.5/cos(alf*pi/2);
% END