function adi_flmm_subeq_c 
% FLMM finite difference methods for D_t^{alf}u = u_xy + u_yy + f(x,y,t)
% 
% Table 4.24: fdm = 5 for ADI (4.291), gamma = alf is the fractional order
% Table 4.24: fdm = 6 for ADI (4.293), gamma = alf is the fractional order
tic
sel = 0; % select the solution
fdm = 5; % 
[uv,gv,Nx,Ny,ntau,nodes,nodes2,nu,T,nalf,uav,ubv,ucv,udv,ut0]=solution(sel);
nn=length(ntau);  ee=zeros(nn,1);  ee2=ee; ee3=ee;ee4=ee;ee5=ee;
for kk=1:nn
    alf = nalf(kk); tau=ntau(kk); N=Nx(kk); N2=Ny(kk);
    switch fdm
%         case 1  
%         [uu,e,e2,e3,abse1,abse2]=adi_fdm11(uv,gv,uav,ubv,ucv,udv,N,N2,tau,nodes,nodes2,nu,T,alf,ut0);
%         case 2
%         [uu,e,e2,e3,abse1,abse2]=adi_fdm12(uv,gv,uav,ubv,ucv,udv,N,N2,tau,nodes,nodes2,nu,T,alf,ut0);
        case 3 % program for method (4.287)
        [uu,e,e2,e3,abse1,abse2]=adi_fdm21(uv,gv,uav,ubv,ucv,udv,N,N2,tau,nodes,nodes2,nu,T,alf,ut0);
        case 4 % program for method (4.289)
        [uu,e,e2,e3,abse1,abse2]=adi_fdm22(uv,gv,uav,ubv,ucv,udv,N,N2,tau,nodes,nodes2,nu,T,alf,ut0);
        case 5 % program for method (4.291)
        [uu,e,e2,e3,abse1,abse2]=adi_fdm31(uv,gv,uav,ubv,ucv,udv,N,N2,tau,nodes,nodes2,nu,T,alf,ut0);
        case 6 % program for method (4.293)
        [uu,e,e2,e3,abse1,abse2]=adi_fdm32(uv,gv,uav,ubv,ucv,udv,N,N2,tau,nodes,nodes2,nu,T,alf,ut0);
        case 7 % program for method (4.285)
        [uu,e,e2,e3,abse1,abse2]=adi_L1_fdm(uv,gv,uav,ubv,ucv,udv,N,N2,tau,nodes,nodes2,nu,T,alf,ut0);
    end
    ee(kk) = e; ee2(kk) = e2; ee3(kk) = e3;
    ee4(kk) = abse1; ee5(kk) = abse2;
end
odr = myorder(1./Nx,ntau,ee);  odr2 = myorder(1./Nx,ntau,ee2);  
odr3 = myorder(1./Nx,ntau,ee3);  odr4 = myorder(1./Nx,ntau,ee4); 
odr5 = myorder(1./Nx,ntau,ee5);  
fid = fopen('adi_flmm_Sub_Eq_I.txt','a');
fprintf('alf = %s,  T = %s\n',num2str(alf),num2str(T));
A=[Nx,1./ntau,ee,odr,ee2,odr2,ee3,odr3,ee4,odr4,ee5,odr5];
s={'N','1/tau','max-L2','order','average-L^2','order','L^2','order','max-L^inf','order','L^inf','order'};
output(s,A);
fprintf('cputime = %-10.4f\n\n',toc);
% % % % % % % % % % % % % % % % % % % % % 
fprintf(fid,'alf = %s, T = %s\n',num2str(alf),num2str(T));
output1(s,A,fid); 
fprintf(fid,'cputime = %-10.4f\n\n',toc);
% END

function [uu,e,e2,e3,abse1,abse2]=adi_fdm11(uv,gv,uav,ubv,ucv,udv,N,N2,tau,nodes,nodes2,nu,T,alf,ut0)
% % uniform grids
xa = nodes(1);   xb=nodes(2);    xa2=nodes2(1);  xb2=nodes2(2);
h = (xb-xa)/N;   xx = xa:h:xb+1e-10;  xx=xx';   xxx=xx;
h2 = (xb2-xa2)/N2;   yy = xa2:h2:xb2+1e-10;  yy=yy';   yyy=yy;
p = 1;
[mhx,mhy] = meshgrid(xxx,yyy);  mhx = mhx'; mhy = mhy';
% % % % % % 
ne = round(T/tau)+1;    r = nu*(tau/2)^alf;             
w = weights(alf,ne,1);
w2 = w;   w2(2:2:end) = -w2(2:2:end); 
w3 = (tau/2)^alf*w2;    w2 = r*w2;
b = w; 
for k=1:ne
    b(k+1) = b(k)+w(k+1);
end
w = -w;
% 
ww3 = (1/2)^alf*weights(alf,ne,1); ww3(2:2:end)=-ww3(2:2:end);


mm = eye(N+1)*h; ss = zeros(N+1);
for i=2:N
    ss(i,i-1:i+1) = [-1,2,-1];
end
ss = ss/h;

mmy = eye(N2+1)*h2; ssy = zeros(N2+1);
for i=2:N2
    ssy(i,i-1:i+1) = [-1,2,-1];
end
ssy = ssy/h2;
mm0 = mm; mm0y = mmy;

arr = mm + nu*(tau/2)^alf*ss;  arry = mmy + nu*(tau/2)^alf*ssy;
arr = arr(2:end-1,:);          arry = arry(2:end-1,:);  
mat = sparse(arr);             matyt = sparse(arry');

arr =sparse(arr(:,2:end-1));     arryt =sparse(arry(:,2:end-1))';
mm = sparse(mm(2:end-1,:));      ss=sparse(ss(2:end-1,:));
mmyt = sparse(mmy(2:end-1,:))';  ssyt=sparse(ssy(2:end-1,:))';
%------------- initial ------------
uu = zeros(p*N+1,p*N2+1,ne); 
u0 = ut0(mhx,mhy,alf);   uu(:,:,1) = u0; 
tt = 0:tau:T+1e-10;
ff = zeros(p*N+1,p*N2+1,ne);
for k=1:ne
    ff(:,:,k) = gv(mhx,mhy,tt(k),alf);
end
% a0 = 1-alf;  % 
% gg2 = fint(ff,tt,alf,a0);   % fractonal integral of the right hand side
gg=zeros(p*N-1,p*N2-1,ne);
for k=1:ne
    gg(:,:,k) = mm*ff(:,:,k)*mmyt;     %
end
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % 
%-----------------------------
nu0 = nu^2*(tau/2)^(2*alf);
for n = 1:ne-1      
    bndu = uv(mhx,mhy,tt(n+1));  bndu(2:end-1,2:end-1) = 0;
    rhs =  b(n+1)*u0; 
    rhs1 = 0;  
%     rhs2 = w(1)*gg(:,:,n+1);
    rhs2 = w3(1)*gg(:,:,n+1);
    for k=1:n
        rhs = rhs + w(k+1)*uu(:,:,n+1-k);
        rhs1 = rhs1 + w2(k+1)*uu(:,:,n+1-k);
        rhs2 = rhs2 + w3(k+1)*gg(:,:,n+1-k);
%         rhs2 = rhs2 + w(k+1)*gg(:,:,n+1-k);
    end
    rhs = mm*rhs*mmyt - (mm*rhs1*ssyt+ss*rhs1*mmyt) - mat*bndu*matyt + rhs2.....
        + nu0*(ss*uu(:,:,n)*ssyt);
    u2 = arr\rhs;  u2 = (arryt\u2')';
    uu(:,:,n+1) = bndu;  uu(2:end-1,2:end-1,n+1) = u2;
end
e3 = funuv(uv,mhx,mhy,tt,alf)-uu;  
abse1 = max(max(max(abs(e3))));
abse2 = max(max(abs(e3(:,:,ne))));
e4 = zeros(1,ne);  
e3 = e3.^2;
for k=1:ne
    e4(k) = sum(sum((mm0*e3(:,:,k)*mm0y')));
end
e = max(sqrt((e4))); 
e2 = sqrt(tau*sum(e4));
e3 = sqrt(e4(ne));
%END
function [uu,e,e2,e3,abse1,abse2]=adi_fdm12(uv,gv,uav,ubv,ucv,udv,N,N2,tau,nodes,nodes2,nu,T,alf,ut0)
% % uniform grids
xa = nodes(1);   xb=nodes(2);    xa2=nodes2(1);  xb2=nodes2(2);
h = (xb-xa)/N;   xx = xa:h:xb+1e-10;  xx=xx';   xxx=xx;
h2 = (xb2-xa2)/N2;   yy = xa2:h2:xb2+1e-10;  yy=yy';   yyy=yy;
p = 1;
[mhx,mhy] = meshgrid(xxx,yyy);  mhx = mhx'; mhy = mhy';
% % % % % % % % % % % %
ne = round(T/tau)+1;  r = nu*tau^alf*alf/2;             
w = weights(alf,ne,1);  
w3 = tau^alf*[1-alf/2,alf/2];
w2 = r;
b = w; 
for k=1:ne
    b(k+1) = b(k) + w(k+1);
end
w = -w;
% % % % % % % % % % % % % % % % % % % % % % % % % %
ww3 = zeros(ne,1); ww3(1:2) = [1-alf/2,alf/2];


mm = eye(N+1)*h; ss = zeros(N+1);
for i=2:N
    ss(i,i-1:i+1) = [-1,2,-1];
end
ss = ss/h;

mmy = eye(N2+1)*h2; ssy = zeros(N2+1);
for i=2:N2
    ssy(i,i-1:i+1) = [-1,2,-1];
end
ssy = ssy/h2;
mm0 = mm; mm0y = mmy;

arr = mm + nu*tau^alf*(1-alf/2)*ss;  arry = mmy + nu*tau^alf*(1-alf/2)*ssy;
arr = arr(2:end-1,:);          arry = arry(2:end-1,:);  
mat = sparse(arr);             matyt = sparse(arry');

arr =sparse(arr(:,2:end-1));     arryt =sparse(arry(:,2:end-1))';
mm = sparse(mm(2:end-1,:));      ss=sparse(ss(2:end-1,:));
mmyt = sparse(mmy(2:end-1,:))';  ssyt=sparse(ssy(2:end-1,:))';
%------------- initial ------------
uu = zeros(p*N+1,p*N2+1,ne); 
u0 = ut0(mhx,mhy,alf);   uu(:,:,1) = u0; 
tt = 0:tau:T+1e-10;
ff = zeros(p*N+1,p*N2+1,ne);
for k=1:ne
    ff(:,:,k) = gv(mhx,mhy,tt(k),alf);
end
% a0 = 1-alf;  % 
% gg2 = fint(ff,tt,alf,a0);   % fractonal integral of the right hand side
gg=zeros(p*N-1,p*N2-1,ne);
for k=1:ne
    gg(:,:,k) = mm*ff(:,:,k)*mmyt;     %
end
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % 
%-----------------------------
nu0 = (nu*tau^alf*(1-alf/2))^2;
for n = 1:ne-1      
    bndu = uv(mhx,mhy,tt(n+1));  bndu(2:end-1,2:end-1) = 0;
%     ua = uav(tt(n+1));   ub = ubv(tt(n+1)); 
    rhs =  b(n+1)*u0; 
%     rhs1 = w(1)*gg(:,:,n+1); 
    rhs1 = w3(1)*gg(:,:,n+1) + w3(2)*gg(:,:,n);
    for k=1:n
        rhs = rhs + w(k+1)*uu(:,:,n+1-k);
%         rhs1 = rhs1 + w(k+1)*gg(:,:,n+1-k);
    end
    rhs = mm*rhs*mmyt - w2*(mm*uu(:,:,n)*ssyt+ss*uu(:,:,n)*mmyt)....
        - mat*bndu*matyt + rhs1 + nu0*(ss*uu(:,:,n)*ssyt);
    u2 = arr\rhs;  u2 = (arryt\u2')';
    uu(:,:,n+1) = bndu;  uu(2:end-1,2:end-1,n+1) = u2;
end
e3 = funuv(uv,mhx,mhy,tt,alf)-uu;  
abse1 = max(max(max(abs(e3))));
abse2 = max(max(abs(e3(:,:,ne))));
e4 = zeros(1,ne);  
e3 = e3.^2;
for k=1:ne
    e4(k) = sum(sum((mm0*e3(:,:,k)*mm0y')));
end
e = max(sqrt((e4))); 
e2 = sqrt(tau*sum(e4));
e3 = sqrt(e4(ne));
%END

function [uu,e,e2,e3,abse1,abse2]=adi_fdm21(uv,gv,uav,ubv,ucv,udv,N,N2,tau,nodes,nodes2,nu,T,alf,ut0)
% % uniform grids
xa = nodes(1);   xb=nodes(2);    xa2=nodes2(1);  xb2=nodes2(2);
h = (xb-xa)/N;   xx = xa:h:xb+1e-10;  xx=xx';   xxx=xx;
h2 = (xb2-xa2)/N2;   yy = xa2:h2:xb2+1e-10;  yy=yy';   yyy=yy;
p = 1;
[mhx,mhy] = meshgrid(xxx,yyy);  mhx = mhx'; mhy = mhy';
% % % % % % 
ne = round(T/tau)+1;    r = nu*(tau/2)^alf;             
w = weights(alf,ne,1);
w2 = w;   w2(2:2:end) = -w2(2:2:end); 
w3 = (tau/2)^alf*w2;    w2 = r*w2;
b = w; 
for k=1:ne
    b(k+1) = b(k)+w(k+1);
end
w = -w;
% 
ww3 = (1/2)^alf*weights(alf,ne,1); ww3(2:2:end)=-ww3(2:2:end);
k=0:ne;
B0 = k.^(alf)/gamma(alf+1);  B=B0;
for k=1:ne
    B(k) = (-B0(1:k)*w(k:-1:1)-sum(ww3(1:k)));
end
B = nu*tau^alf*B;
% % % % % % % % % % % %
% [mm,ss] = basis(p,N,xx);     mm0 = mm;
% [mmy,ssy] = basis(p,N2,yy);  mm0y = mmy;


mm = eye(N+1)*h; ss = zeros(N+1);
for i=2:N
    ss(i,i-1:i+1) = [-1,2,-1];
end
ss = ss/h;

mmy = eye(N2+1)*h2; ssy = zeros(N2+1);
for i=2:N2
    ssy(i,i-1:i+1) = [-1,2,-1];
end
ssy = ssy/h2;
mm0 = mm; mm0y = mmy;

arr = mm + nu*(tau/2)^alf*ss;  arry = mmy + nu*(tau/2)^alf*ssy;
arr = arr(2:end-1,:);          arry = arry(2:end-1,:);  
mat = sparse(arr);             matyt = sparse(arry');

arr =sparse(arr(:,2:end-1));     arryt =sparse(arry(:,2:end-1))';
mm = sparse(mm(2:end-1,:));      ss=sparse(ss(2:end-1,:));
mmyt = sparse(mmy(2:end-1,:))';  ssyt=sparse(ssy(2:end-1,:))';
%------------- initial ------------
uu = zeros(p*N+1,p*N2+1,ne); 
u0 = ut0(mhx,mhy,alf);   uu(:,:,1) = u0; 
tt = 0:tau:T+1e-10;
ff = zeros(p*N+1,p*N2+1,ne);
for k=1:ne
    ff(:,:,k) = gv(mhx,mhy,tt(k),alf);
end
a0 = 1-alf;  % 
gg2 = fint(ff,tt,alf,a0);   % fractonal integral of the right hand side
gg=zeros(p*N-1,p*N2-1,ne);
for k=1:ne
    gg(:,:,k) = mm*gg2(:,:,k)*mmyt;     %
end
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % 
%-----------------------------
nu0 = nu^2*(tau/2)^(2*alf);
for n = 1:ne-1      
    bndu = uv(mhx,mhy,tt(n+1));  bndu(2:end-1,2:end-1) = 0;
    rhs =  b(n+1)*u0; 
    rhs1 = 0;  
    rhs2 = w(1)*gg(:,:,n+1);
    for k=1:n
        rhs = rhs + w(k+1)*uu(:,:,n+1-k);
        rhs1 = rhs1 + w2(k+1)*uu(:,:,n+1-k);
        rhs2 = rhs2 + w(k+1)*gg(:,:,n+1-k);
    end
    rhs = mm*rhs*mmyt - (mm*rhs1*ssyt+ss*rhs1*mmyt) - mat*bndu*matyt - rhs2.....
        - B(n+1)*(mm*u0*ssyt+ss*u0*mmyt) + nu0*(ss*uu(:,:,n)*ssyt);
    u2 = arr\rhs;  u2 = (arryt\u2')';
    uu(:,:,n+1) = bndu;  uu(2:end-1,2:end-1,n+1) = u2;
end
e3 = funuv(uv,mhx,mhy,tt,alf)-uu;  
abse1 = max(max(max(abs(e3))));
abse2 = max(max(abs(e3(:,:,ne))));
e4 = zeros(1,ne);   e3 = e3.^2;
for k=1:ne
    e4(k) = sum(sum((mm0*e3(:,:,k)*mm0y')));
end
e = max(sqrt((e4))); 
e2 = sqrt(tau*sum(e4));
e3 = sqrt(e4(ne));
%END
function [uu,e,e2,e3,abse1,abse2]=adi_fdm22(uv,gv,uav,ubv,ucv,udv,N,N2,tau,nodes,nodes2,nu,T,alf,ut0)
% % uniform grids
xa = nodes(1);   xb=nodes(2);    xa2=nodes2(1);  xb2=nodes2(2);
h = (xb-xa)/N;   xx = xa:h:xb+1e-10;  xx=xx';   xxx=xx;
h2 = (xb2-xa2)/N2;   yy = xa2:h2:xb2+1e-10;  yy=yy';   yyy=yy;
p = 1;
[mhx,mhy] = meshgrid(xxx,yyy);  mhx = mhx'; mhy = mhy';
% % % % % % % % % % % %
ne = round(T/tau)+1;  r = nu*tau^alf*alf/2;             
w = weights(alf,ne,1);  
w3 = tau^alf*[1-alf/2,alf/2];
w2 = r;
b = w; 
for k=1:ne
    b(k+1) = b(k) + w(k+1);
end
w = -w;
% % % % % % % % % % % % % % % % % % % % % % % % % %
ww3 = zeros(ne,1); ww3(1:2) = [1-alf/2,alf/2];
k=0:ne;
B0 = k.^(alf)/gamma(alf+1);  B=B0;
for k=1:ne
    B(k) = nu*tau^alf*(-B0(1:k)*w(k:-1:1)-sum(ww3(1:k)));
end
% % % % % % % % % % % % % % % % % %
% [mm,ss] = basis(p,N,xx);     mm0 = mm;
% [mmy,ssy] = basis(p,N2,yy);  mm0y = mmy;

mm = eye(N+1)*h; ss = zeros(N+1);
for i=2:N
    ss(i,i-1:i+1) = [-1,2,-1];
end
ss = ss/h;

mmy = eye(N2+1)*h2; ssy = zeros(N2+1);
for i=2:N2
    ssy(i,i-1:i+1) = [-1,2,-1];
end
ssy = ssy/h2;
mm0 = mm; mm0y = mmy;

arr = mm + nu*tau^alf*(1-alf/2)*ss;  arry = mmy + nu*tau^alf*(1-alf/2)*ssy;
arr = arr(2:end-1,:);          arry = arry(2:end-1,:);  
mat = sparse(arr);             matyt = sparse(arry');

arr =sparse(arr(:,2:end-1));     arryt =sparse(arry(:,2:end-1))';
mm = sparse(mm(2:end-1,:));      ss=sparse(ss(2:end-1,:));
mmyt = sparse(mmy(2:end-1,:))';  ssyt=sparse(ssy(2:end-1,:))';
%------------- initial ------------
uu = zeros(p*N+1,p*N2+1,ne); 
u0 = ut0(mhx,mhy,alf);   uu(:,:,1) = u0; 
tt = 0:tau:T+1e-10;
ff = zeros(p*N+1,p*N2+1,ne);
for k=1:ne
    ff(:,:,k) = gv(mhx,mhy,tt(k),alf);
end
a0 = 1-alf;  % 
gg2 = fint(ff,tt,alf,a0);   % fractonal integral of the right hand side
gg=zeros(p*N-1,p*N2-1,ne);
for k=1:ne
    gg(:,:,k) = mm*gg2(:,:,k)*mmyt;     %
end
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % 
%-----------------------------
nu0 = (nu*tau^alf*(1-alf/2))^2;
for n = 1:ne-1      
    bndu = uv(mhx,mhy,tt(n+1));  bndu(2:end-1,2:end-1) = 0;
%     ua = uav(tt(n+1));   ub = ubv(tt(n+1)); 
    rhs =  b(n+1)*u0; 
    rhs1 = w(1)*gg(:,:,n+1);  
    for k=1:n
        rhs = rhs + w(k+1)*uu(:,:,n+1-k);
        rhs1 = rhs1 + w(k+1)*gg(:,:,n+1-k);
    end
    rhs = mm*rhs*mmyt - w2*(mm*uu(:,:,n)*ssyt+ss*uu(:,:,n)*mmyt)....
        - mat*bndu*matyt - B(n+1)*(mm*u0*ssyt+ss*u0*mmyt) - rhs1....
        + nu0*(ss*uu(:,:,n)*ssyt);
    u2 = arr\rhs;  u2 = (arryt\u2')';
    uu(:,:,n+1) = bndu;  uu(2:end-1,2:end-1,n+1) = u2;
end
e3 = funuv(uv,mhx,mhy,tt,alf)-uu;  
abse1 = max(max(max(abs(e3))));
abse2 = max(max(abs(e3(:,:,ne))));
e4 = zeros(1,ne);  
e3 = e3.^2;
for k=1:ne
    e4(k) = sum(sum((mm0*e3(:,:,k)*mm0y')));
end
e = max(sqrt((e4))); 
e2 = sqrt(tau*sum(e4));
e3 = sqrt(e4(ne));
%END

function [uu,e,e2,e3,abse1,abse2]=adi_fdm31(uv,gv,uav,ubv,ucv,udv,N,N2,tau,nodes,nodes2,nu,T,alf,ut0)
% % uniform grids
xa = nodes(1);   xb=nodes(2);    xa2=nodes2(1);  xb2=nodes2(2);
h = (xb-xa)/N;   xx = xa:h:xb+1e-10;  xx=xx';   xxx=xx;
h2 = (xb2-xa2)/N2;   yy = xa2:h2:xb2+1e-10;  yy=yy';   yyy=yy;
p = 1;
[mhx,mhy] = meshgrid(xxx,yyy);  mhx = mhx'; mhy = mhy';
% % % % % % 
ne = round(T/tau)+1;    r = nu*(tau/2)^alf;             
w = weights(alf,ne,1);
w2 = w;   w2(2:2:end) = -w2(2:2:end); 
w3 = (tau/2)^alf*w2;    w2 = r*w2;
b = w; 
for k=1:ne
    b(k+1) = b(k)+w(k+1);
end
w = -w;
% 
ww3 = (1/2)^alf*weights(alf,ne,1); ww3(2:2:end)=-ww3(2:2:end);
k=0:ne;
B0 = k.^(alf)/gamma(alf+1);  B=B0;
for k=1:ne
    B(k) = (-B0(1:k)*w(k:-1:1)-sum(ww3(1:k)));
end
B = nu*tau^alf*B;
% % % % % % % % % % % %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
om0 = weights(alf,ne,1);
om1 = om0/2^(alf);      om1(2:2:end) = - om1(2:2:end);
om2 = weights(-alf,ne,1).';
om = zeros(ne,1);
for k=1:ne
    om(k) = om2(1:k)*om1(k:-1:1);
end
wn1 = (1:ne).^(1+alf)/gamma(2+alf);
k = 1:ne;
for n=1:ne
    wn1(n) =  wn1(n) - k(1:n)*om(n:-1:1);
end
kk = k.^(alf+1)/gamma(2+alf);
C = B; CC = C;
for n=1:ne
    C(n) = wn1(1:n)*om0(n:-1:1);
    CC(n) = kk(1:n)*om0(n:-1:1) - k(1:n)*om1(n:-1:1);
end
C = nu*tau^alf*CC;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [mm,ss] = basis(p,N,xx);     mm0 = mm;
% [mmy,ssy] = basis(p,N2,yy);  mm0y = mmy;

mm = eye(N+1)*h; ss = zeros(N+1);
for i=2:N
    ss(i,i-1:i+1) = [-1,2,-1];
end
ss = ss/h;

mmy = eye(N2+1)*h2; ssy = zeros(N2+1);
for i=2:N2
    ssy(i,i-1:i+1) = [-1,2,-1];
end
ssy = ssy/h2;
mm0 = mm; mm0y = mmy;

arr = mm + nu*(tau/2)^alf*ss;  arry = mmy + nu*(tau/2)^alf*ssy;
arr = arr(2:end-1,:);          arry = arry(2:end-1,:);  
mat = sparse(arr);             matyt = sparse(arry');

arr =sparse(arr(:,2:end-1));     arryt =sparse(arry(:,2:end-1))';
mm = sparse(mm(2:end-1,:));      ss=sparse(ss(2:end-1,:));
mmyt = sparse(mmy(2:end-1,:))';  ssyt=sparse(ssy(2:end-1,:))';
%------------- initial ------------
uu = zeros(p*N+1,p*N2+1,ne); 
u0 = ut0(mhx,mhy,alf);   uu(:,:,1) = u0; 
u1 = uv(mhx,mhy,tau,alf);   uu(:,:,2) = u1; 
tt = 0:tau:T+1e-10;
ff = zeros(p*N+1,p*N2+1,ne);
for k=1:ne
    ff(:,:,k) = gv(mhx,mhy,tt(k),alf);
end
a0 = 1-alf;  % 
gg2 = fint(ff,tt,alf,a0);   % fractonal integral of the right hand side
gg=zeros(p*N-1,p*N2-1,ne);
for k=1:ne
    gg(:,:,k) = mm*gg2(:,:,k)*mmyt;     %
end
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % 
%-----------------------------
nu0 = nu^2*(tau/2)^(2*alf); u10 = u1-u0;
for n = 2:ne-1      
    bndu = uv(mhx,mhy,tt(n+1));  bndu(2:end-1,2:end-1) = 0;
    rhs =  b(n+1)*u0; 
    rhs1 = 0;  
    rhs2 = w(1)*gg(:,:,n+1);
    for k=1:n
        rhs = rhs + w(k+1)*uu(:,:,n+1-k);
        rhs1 = rhs1 + w2(k+1)*uu(:,:,n+1-k);
        rhs2 = rhs2 + w(k+1)*gg(:,:,n+1-k);
    end
    rhs = mm*rhs*mmyt - (mm*rhs1*ssyt+ss*rhs1*mmyt) - mat*bndu*matyt - rhs2.....
        - B(n+1)*(mm*u0*ssyt+ss*u0*mmyt) + nu0*(ss*uu(:,:,n)*ssyt).....
        - C(n)*(mm*u10*ssyt+ss*u10*mmyt);
    u2 = arr\rhs;  u2 = (arryt\u2')';
    uu(:,:,n+1) = bndu;  uu(2:end-1,2:end-1,n+1) = u2;
end
e3 = funuv(uv,mhx,mhy,tt,alf)-uu;  
abse1 = max(max(max(abs(e3))));
abse2 = max(max(abs(e3(:,:,ne))));
e4 = zeros(1,ne);  
e3 = e3.^2;
for k=1:ne
    e4(k) = sum(sum((mm0*e3(:,:,k)*mm0y')));
end
e = max(sqrt((e4))); 
e2 = sqrt(tau*sum(e4));
e3 = sqrt(e4(ne));
%END

function [uu,e,e2,e3,abse1,abse2]=adi_fdm32(uv,gv,uav,ubv,ucv,udv,N,N2,tau,nodes,nodes2,nu,T,alf,ut0)
% % uniform grids
xa = nodes(1);   xb=nodes(2);    xa2=nodes2(1);  xb2=nodes2(2);
h = (xb-xa)/N;   xx = xa:h:xb+1e-10;  xx=xx';   xxx=xx;
h2 = (xb2-xa2)/N2;   yy = xa2:h2:xb2+1e-10;  yy=yy';   yyy=yy;
p = 1;
[mhx,mhy] = meshgrid(xxx,yyy);  mhx = mhx'; mhy = mhy';
% % % % % % % % % % % %
ne = round(T/tau)+1;  r = nu*tau^alf*alf/2;             
w = weights(alf,ne,1);  
w3 = tau^alf*[1-alf/2,alf/2];
w2 = r;
b = w; 
for k=1:ne
    b(k+1) = b(k) + w(k+1);
end
w = -w;
% % % % % % % % % % % % % % % % % % % % % % % % % %
ww3 = zeros(ne,1); ww3(1:2) = [1-alf/2,alf/2];
k=0:ne;
B0 = k.^(alf)/gamma(alf+1);  B=B0;
for k=1:ne
    B(k) = nu*tau^alf*(-B0(1:k)*w(k:-1:1)-sum(ww3(1:k)));
end
% % % % % % % % % % % % % % % % % %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
om0 = weights(alf,ne,1);
om1 = zeros(ne+1,1);    om1(1:2) = [1-alf/2,alf/2];
om2 = weights(-alf,ne,1).';
om = zeros(ne,1);
for k=1:ne
    om(k) = om2(1:k)*om1(k:-1:1);
end
wn1 = (1:ne).^(1+alf)/gamma(2+alf);
k = 1:ne;
for n=1:ne
    wn1(n) =  wn1(n) - k(1:n)*om(n:-1:1);
end
kk = k.^(alf+1)/gamma(2+alf);
C = B; CC = C;
for n=1:ne
    C(n) = wn1(1:n)*om0(n:-1:1);
    CC(n) = kk(1:n)*om0(n:-1:1) - k(1:n)*om1(n:-1:1);
end
C = nu*tau^alf*CC;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [mm,ss] = basis(p,N,xx);     mm0 = mm;
% [mmy,ssy] = basis(p,N2,yy);  mm0y = mmy;

mm = eye(N+1)*h; ss = zeros(N+1);
for i=2:N
    ss(i,i-1:i+1) = [-1,2,-1];
end
ss = ss/h;

mmy = eye(N2+1)*h2; ssy = zeros(N2+1);
for i=2:N2
    ssy(i,i-1:i+1) = [-1,2,-1];
end
ssy = ssy/h2;
mm0 = mm; mm0y = mmy;

arr = mm + nu*tau^alf*(1-alf/2)*ss;  arry = mmy + nu*tau^alf*(1-alf/2)*ssy;
arr = arr(2:end-1,:);          arry = arry(2:end-1,:);  
mat = sparse(arr);             matyt = sparse(arry');

arr =sparse(arr(:,2:end-1));     arryt =sparse(arry(:,2:end-1))';
mm = sparse(mm(2:end-1,:));      ss=sparse(ss(2:end-1,:));
mmyt = sparse(mmy(2:end-1,:))';  ssyt=sparse(ssy(2:end-1,:))';
%------------- initial ------------
uu = zeros(p*N+1,p*N2+1,ne); 
u0 = ut0(mhx,mhy,alf);      uu(:,:,1) = u0; 
u1 = uv(mhx,mhy,tau,alf);   uu(:,:,2) = u1;
tt = 0:tau:T+1e-10;
ff = zeros(p*N+1,p*N2+1,ne);
for k=1:ne
    ff(:,:,k) = gv(mhx,mhy,tt(k),alf);
end
a0 = 1-alf;  % 
gg2 = fint(ff,tt,alf,a0);   % fractonal integral of the right hand side
gg=zeros(p*N-1,p*N2-1,ne);
for k=1:ne
    gg(:,:,k) = mm*gg2(:,:,k)*mmyt;     %
end
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % 
%-----------------------------
nu0 = (nu*tau^alf*(1-alf/2))^2;  u10 = u1-u0;
% dduu = zeros(p*N-1,p*N2-1,ne);   duu = dduu;
% duu(:,:,1)=mm*uu(:,:,1)*ssyt+ss*uu(:,:,1)*mmyt;
% duu(:,:,2)=mm*uu(:,:,2)*ssyt+ss*uu(:,:,2)*mmyt;
% dduu(:,:,1)=ss*uu(:,:,1)*ssyt;
% dduu(:,:,2)=ss*uu(:,:,2)*ssyt;
duu10 = mm*u10*ssyt+ss*u10*mmyt;
for n = 2:ne-1      
    bndu = uv(mhx,mhy,tt(n+1));  bndu(2:end-1,2:end-1) = 0;
%     ua = uav(tt(n+1));   ub = ubv(tt(n+1)); 
    rhs =  b(n+1)*u0; 
    rhs1 = w(1)*gg(:,:,n+1);  
    for k=1:n
        rhs = rhs + w(k+1)*uu(:,:,n+1-k);
        rhs1 = rhs1 + w(k+1)*gg(:,:,n+1-k);
    end
    rhs = mm*rhs*mmyt - w2*(mm*uu(:,:,n)*ssyt+ss*uu(:,:,n)*mmyt)....
        - mat*bndu*matyt - B(n+1)*(mm*u0*ssyt+ss*u0*mmyt) - rhs1....
        + nu0*(ss*uu(:,:,n)*ssyt) - C(n)*duu10;
    u2 = arr\rhs;  u2 = (arryt\u2')';
    uu(:,:,n+1) = bndu;  uu(2:end-1,2:end-1,n+1) = u2;
end
e3 = funuv(uv,mhx,mhy,tt,alf)-uu; 
abse1 = max(max(max(abs(e3))));
abse2 = max(max(abs(e3(:,:,ne))));
e4 = zeros(1,ne);  
e3 = e3.^2;
for k=1:ne
    e4(k) = sum(sum((mm0*e3(:,:,k)*mm0y')));
end
e = sqrt(max(e4)); 
e2 = sqrt(tau*sum(e4));
e3 = sqrt(e4(ne));
%END

function [uu,e,e2,e3,abse1,abse2]=adi_L1_fdm(uv,gv,uav,ubv,ucv,udv,N,N2,tau,nodes,nodes2,nu,T,alf,ut0)
% % uniform grids
xa = nodes(1);   xb=nodes(2);    xa2=nodes2(1);  xb2=nodes2(2);
h = (xb-xa)/N;   xx = xa:h:xb+1e-10;  xx=xx';   xxx=xx;
h2 = (xb2-xa2)/N2;   yy = xa2:h2:xb2+1e-10;  yy=yy';   yyy=yy;
p = 1;
[mhx,mhy] = meshgrid(xxx,yyy);  mhx = mhx'; mhy = mhy';
% % % % % % 
ne = round(T/tau)+1;  
r = nu*tau^alf*gamma(2-alf);     r0 = tau^alf*gamma(2-alf);  r2=r^2;       
% w = weights(alf,ne,1);  
k = 0:ne; 
b = (k+1).^(1-alf) - k.^(1-alf);
w = b(1:end-1) - b(2:end);
% % % % % % % % % % % % % % % % % %
% [mm,ss] = basis(p,N,xx);     mm0 = mm;
% [mmy,ssy] = basis(p,N2,yy);  mm0y = mmy;

mm = eye(N+1)*h; ss = zeros(N+1);
for i=2:N
    ss(i,i-1:i+1) = [-1,2,-1];
end
ss = ss/h;

mmy = eye(N2+1)*h2; ssy = zeros(N2+1);
for i=2:N2
    ssy(i,i-1:i+1) = [-1,2,-1];
end
ssy = ssy/h2;
mm0 = mm; mm0y = mmy;

arr = mm + r*ss;         arry = mmy + r*ssy;
arr = arr(2:end-1,:);    arry = arry(2:end-1,:);  
mat = sparse(arr);       matyt = sparse(arry');

arr =sparse(arr(:,2:end-1));     arryt =sparse(arry(:,2:end-1))';
mm = sparse(mm(2:end-1,:));      ss=sparse(ss(2:end-1,:));
mmyt = sparse(mmy(2:end-1,:))';  ssyt=sparse(ssy(2:end-1,:))';
%------------- initial ------------
uu = zeros(p*N+1,p*N2+1,ne); 
u0 = ut0(mhx,mhy,alf);      uu(:,:,1) = u0; 
tt = 0:tau:T+1e-10;
% ff = zeros(p*N+1,p*N2+1,ne);
% for k=1:ne
%     ff(:,:,k) = gv(mhx,mhy,tt(k),alf);
% end
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % 
%-----------------------------
for n = 1:ne-1      
    bndu = uv(mhx,mhy,tt(n+1));  bndu(2:end-1,2:end-1) = 0;
    rhs =  b(n)*u0;  gg = mm*gv(mhx,mhy,tt(n+1),alf)*mmyt;
    for k=1:n-1
        rhs = rhs + w(k)*uu(:,:,n+1-k);
    end
    rhs = mm*rhs*mmyt - mat*bndu*matyt + r0*gg + r2*(ss*uu(:,:,n)*ssyt);
    u2 = arr\rhs;  u2 = (arryt\u2')';
    uu(:,:,n+1) = bndu;  uu(2:end-1,2:end-1,n+1) = u2;
end
e3 = funuv(uv,mhx,mhy,tt,alf)-uu;  
abse1 = max(max(max(abs(e3))));
abse2 = max(max(abs(e3(:,:,ne))));
e4 = zeros(1,ne);  
e3 = e3.^2;
for k=1:ne
    e4(k) = sum(sum((mm0*e3(:,:,k)*mm0y')));
end
e = sqrt(max(e4)); 
e2 = sqrt(tau*sum(e4));
e3 = sqrt(e4(ne));
%END

function gg2 = fint(ff,tt,alf,a0)
% ne = length(tt);
[rows,cols,ne] = size(ff);      tau = tt(2)-tt(1);
w0 = weights(-alf,ne,1);   ww2 = w0;
ww2(1) = (1-alf/2)*w0(1);  
ww2(2:end) = (1-alf/2)*w0(2:end)+alf/2*w0(1:end-1);
% a0 = 1-alf; 
wj = w0;   j = (0:ne).^a0;
for n=0:ne
    wj(n+1)=gamma(a0+1)/gamma(a0+1+alf)*n^(alf+a0)-j(1:n+1)*ww2(n+1:-1:1);
end
% 
ww2 = (tau)^alf*ww2;    wj = (tau)^alf*wj;
gv0 = ff(:,:,1);  ff2 = ff;
for k=1:ne
    ff2(:,:,k) = ff(:,:,k) - gv0;
end
gg2 = zeros(rows,cols,ne);
for n = 1:ne
    tem = wj(n)*ff2(:,:,2);
    for k=1:n
        tem = tem + ww2(n+1-k)*ff2(:,:,k);
    end
    gg2(:,:,n) = tem + tt(n)^alf/gamma(alf+1)*gv0;
end
%END

function [uv,gv,Nx,Ny,tau,xnodes,ynodes,nu,T,nalf,uav,ubv,ucv,udv,ut0]=solution(sel)
% ADI FDM for  D_t^{alf}u = u_xy + u_yy + f(x,y,t), 
% alf is the fractional order, 0<alf<=1
switch sel
    case 0
        xnodes=[0,1];  ynodes=[0,1];
        alf = 0.5;   
        T=1;  
        nalf = [1,1,1,1]*alf;  Nx = [100,100,100,100]'*4;  Ny = [100,100,100,100]'*4;  
        tau = 1./[8,16,32,64]'; % stepsize in time
        nv = 1;  nv2 = 2;   nu = 1;
        uv = @(x,y,t,alf) sin(x+y)*(t^nv2+t.^nv + 1);
        gv = @(x,y,t,alf) (gamma(nv+1)/gamma(nv+1-alf)*t^(nv-alf).....
            + gamma(nv2+1)/gamma(nv2+1-alf)*t^(nv2-alf).....
            + 2*nu*(t^2+t^nv+1))*sin(x+y);
        xa=xnodes(1);  xb=xnodes(2);
        yc=ynodes(1);  yd=ynodes(2);
        uav = @(y,t,alf) uv(xa,y,t,alf);
        ubv = @(y,t,alf) uv(xb,y,t,alf);
        ucv = @(x,t,alf) uv(x,yc,t,alf);
        udv = @(x,t,alf) uv(x,yd,t,alf);
        ut0 = @(x,y,alf) uv(x,y,0,alf);
    case 1
% Ya-nan Zhang, Zhi-zhong Sun, JCP 230 (2011) 8713C8728.  Example 1
        xnodes=[0,pi];  ynodes=[0,pi];
        T = 1/2;  
%         Nx = [10,20,40]';  Ny = [10,20,40]';  tau = [1e-3,1e-3,1e-3]';
        nalf = [1,1,1,1]*1/3; Nx = [400,400,400,400]';  Ny = [400,400,400,400]';  
        tau = T./[10,20,40,80]';
        nv = 2;     nu = 1;
        uv = @(x,y,t,alf) sin(x).*sin(y)*t.^nv ;
        gv = @(x,y,t,alf) (gamma(nv+1)/gamma(nv+1-alf)*t^(nv-alf) + 2*nu*t^nv)*sin(x).*sin(y);
        xa=xnodes(1);  xb=xnodes(2);
        yc=ynodes(1);  yd=ynodes(2);
        uav = @(y,t,alf) uv(xa,y,t,alf);
        ubv = @(y,t,alf) uv(xb,y,t,alf);
        ucv = @(x,t,alf) uv(x,yc,t,alf);
        udv = @(x,t,alf) uv(x,yd,t,alf);
        ut0 = @(x,y,alf) uv(x,y,0,alf);
    case 2
% Ya-nan Zhang, Zhi-zhong Sun, JCP 230 (2011) 8713C8728.  Example 2
        xnodes=[0,1];  ynodes=[0,1];
        T = 1;  
%         Nx = [10,20,40]';  Ny = [10,20,40]';  tau = [1e-3,1e-3,1e-3]';
        nalf = [1,1,1,1]*3/4; Nx = [4,8,16,32]';  Ny = [4,8,16,32]';  
        tau = T./[400,400,400,400]';
        nv = 1+nalf(1);     nu = 1;
        uv = @(x,y,t,alf) exp(x+y)*t.^nv ;
        gv = @(x,y,t,alf) (gamma(nv+1)/gamma(nv+1-alf)*t^(nv-alf) - 2*nu*t^nv)*exp(x+y);
        xa=xnodes(1);  xb=xnodes(2);
        yc=ynodes(1);  yd=ynodes(2);
        uav = @(y,t,alf) uv(xa,y,t,alf);
        ubv = @(y,t,alf) uv(xb,y,t,alf);
        ucv = @(x,t,alf) uv(x,yc,t,alf);
        udv = @(x,t,alf) uv(x,yd,t,alf);
        ut0 = @(x,y,alf) uv(x,y,0,alf);
    otherwise
        fprintf('Please select the solution!')
        return; 
end
%END

function odr=myorder(ntau,NN,err)
n=length(ntau); 
tau(1:n,1)=ntau; N(1:n,1)=NN(1:n); 
er(1:n,1)=err(1:n);
if n==1
    odr=0; return;
end
if n>1
    if abs(ntau(1)-ntau(2))>1e-10
        odr=(log(er(1:end-1)./er(2:end)))./log(tau(1:n-1,:)./tau(2:n,:));
    else 
        odr=(log(er(1:end-1)./er(2:end)))./log(N(1:n-1,:)./N(2:n,:));
    end
end
odr=[0;odr];
%END 

function [w2,w]=weights(alf,n0,p)
n=n0+1;   j = 0:n-1;   x0 = j.'*2*pi/n;
switch p
    case 1
        w = ones(n,1); 
        f=@(z)(1-z).^alf;
        for k=1:n-1
            w(k+1)=(k-1-alf)/k*w(k); 
        end
        w2=w;
        w = real(fft(f(exp(i*x0))))/n;
    case 2
        f=@(z)(3/2 - 2*z + 0.5*z.^2).^alf;
%         fs=(3/2 - 2*t + t^2/2).^alf;
%         d1f=diff(fs,t); d1f=subs(d1f,t,0);
%         d2f=diff(fs,t,2); d2f=subs(d2f,t,0);
        w = real(fft(f(exp(i*x0))))/n;
        u=zeros(n,1);  u(1:3) = [3/2;  -2; 1/2];  
        w2=w; w2(1) = (3/2)^alf;
        ii=0:n-1;  u=sparse(u);
        for j=1:n-1
            w2(j+1) = (alf - ii(1:j)/j*(alf+1))*(w2(1:j).*u(j+1:-1:2))/u(1);
        end
%         eee=max(w2-w)
%         eee
    case 3
        f=@(z)(11/6 - 3*z + 3/2*z.^2 - z.^3/3).^alf;
        w=real(fft(f(exp(i*x0))))/n;
        
        u=zeros(n,1);  u(1:p+1) = [11/6; -3; 3/2;-1/3];  
        w2=w;  w2(1) = (u(1))^alf;
        ii=0:n-1;  u=sparse(u);
        for j=1:n-1
            w2(j+1) = (alf - ii(1:j)/j*(alf+1))*(w2(1:j).*u(j+1:-1:2))/u(1);
        end
        eee=max(w2-w);
        eee;
    case 4
        f=@(z)(25/12 - 4*z + 3*z.^2 - 4/3*z.^3 + 1/4*z.^4).^alf;
        w=real(fft(f(exp(i*x0))))/n;
        
        u=zeros(n,1);  u(1:p+1) = [25/12; -4; 3;-4/3;1/4];  
        w2=w;  w2(1) = (u(1))^alf;
        ii=0:n-1;  u=sparse(u);
        for j=1:n-1
            w2(j+1) = (alf - ii(1:j)/j*(alf+1))*(w2(1:j).*u(j+1:-1:2))/u(1);
        end
        eee=max(w2-w);
        eee;
    case 5
        f=@(z)(137/60 - 5*z + 5*z.^2 - 10*z.^3/3 + 5*z.^4/4 - z.^5/5).^alf;
        w=real(fft(f(exp(i*x0))))/n;
        
        u=zeros(n,1);  u(1:p+1) = [137/60; -5; 5; -10/3; 5/4; -1/5];  
        w2=w;  w2(1) = (u(1))^alf;
        ii=0:n-1;  u=sparse(u);
        for j=1:n-1
            w2(j+1) = (alf - ii(1:j)/j*(alf+1))*(w2(1:j).*u(j+1:-1:2))/u(1);
        end
        eee=max(w2-w);
        eee;
    case 6
        f=@(z)(147/60 - 6*z + 15/2*z.^2 - 20/3*z.^3 + 15/4*z.^4 - 6/5*z.^5 +z.^6/6).^alf;
        w=real(fft(f(exp(i*x0))))/n;
        
        u=zeros(n,1);  u(1:p+1) = [147/60; -6; 15/2; -20/3; 15/4; -6/5; 1/6];  
        w2=w;  w2(1) = (u(1))^alf;
        ii=0:n-1;  u=sparse(u);
        for j=1:n-1
            w2(j+1) = (alf - ii(1:j)/j*(alf+1))*(w2(1:j).*u(j+1:-1:2))/u(1);
        end
        eee=max(w2-w);
%         eee
end

function output(s,A)
[row,col] = size(A);
fprintf('%-10s%-10s%-16s%-8s%-16s%-8s%-16s%-8s%-16s%-8s%-16s%-8s',s{1},s{2},s{3},s{4},s{5},s{6},s{7},s{8},s{9},s{10},s{11},s{12});
fprintf('\n');
for k=1:row
    fprintf('%-10s%-10s%-16.4e%-8.4f%-16.4e%-8.4f%-16.4e%-8.4f%-16.4e%-8.4f%-16.4e%-8.4f',......
        num2str(A(k,1)),num2str(A(k,2)),A(k,3),A(k,4),A(k,5),A(k,6),A(k,7),A(k,8),A(k,9),A(k,10),A(k,11),A(k,12));
    fprintf('\n');
end
% fprintf('\n');
% END
function output1(s,A,fid)
[row,col] = size(A);
fprintf(fid,'%-10s%-10s%-16s%-8s%-16s%-8s%-16s%-8s%-16s%-8s%-16s%-8s',s{1},s{2},s{3},s{4},s{5},s{6},s{7},s{8},s{9},s{10},s{11},s{12});
fprintf(fid,'\n');
for k=1:row
    fprintf(fid,'%-10s%-10s%-16.4e%-8.4f%-16.4e%-8.4f%-16.4e%-8.4f%-16.4e%-8.4f%-16.4e%-8.4f',......
        num2str(A(k,1)),num2str(A(k,2)),A(k,3),A(k,4),A(k,5),A(k,6),A(k,7),A(k,8),A(k,9),A(k,10),A(k,11),A(k,12));
    fprintf(fid,'\n');
end
fprintf(fid,'\n');
% END
function u=funuv(uv,x,y,t,alf)
nt=length(t); N=length(x); N2=length(y);
u=zeros(N,N2,nt);
for k=1:nt
    u(:,:,k)=uv(x,y,t(k),alf);
end


